

/* Esempio di uso del qsort. 
   Ordinamento di un array in ordine non decrescente */

#include <stdlib.h>
#include <stdio.h>

/* dati due puntatori a intero a e b restituisce 
   -1 se a < b 
    0 se a == b 
    1 se a > b
*/
int compInt(const void *a, const void *b) {
  int ai = *((int *) a); 
  int bi = *((int *) b);
  if(ai < bi) return -1;
  if (ai == bi) return 0; 
  return 1;
}


/* versione alternativa 
  restituisce valore negativo se *a < b, 0 se *a == *b, valore positivo altrimenti
*/
int compInt1(const void *a, const void *b) {
  return *((int *) a) - *((int *) b);
}


int main() {

  /* dichiare un array di interi */  
  int i; 
  int A[8] = {15,45,32,78,11,24,52,84};

  /* ordina A mediante qsort */
  qsort(A, 8, sizeof(int), compInt);

  for( i = 0; i < 8; i++ ) 
	printf("%d\n", A[i]);

  return 0;

}